<?php
/**
 * Installations/admin functions
 */
/**
 * Check if bpchat is installed or not
 */
function bpchat_install(){
global $wpdb, $bp;

	if ( !empty($wpdb->charset) )
		$charset_collate = "DEFAULT CHARACTER SET $wpdb->charset";

	$sql[] = "CREATE TABLE {$bp->chat->table_chat_users} (
                              `user_id` bigint(20) NOT NULL,
                              `is_online` tinyint(4) NOT NULL,
                              `last_active_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
                              `status_message` varchar(255) NOT NULL,
                              `last_fetch_time` datetime NOT NULL COMMENT 'the last message fetch time',
                              `friends_only` tinyint(1) NOT NULL DEFAULT '0'
                            ) {$charset_collate};";
//for media table too

	$sql[] = "CREATE TABLE {$bp->chat->table_chat_channels} (
                       `id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
                      `last_message_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
                      `time_created` datetime NOT NULL,
                      `status` tinyint(3) unsigned NOT NULL,
                      `is_multichat` tinyint(3) NOT NULL,
                      `is_open` tinyint(4) NOT NULL,
                      PRIMARY KEY (`id`)
	 	   ) {$charset_collate};";

	$sql[] = "CREATE TABLE {$bp->chat->table_channel_users} (
			`channel_id` bigint(20) NOT NULL,
                        `user_id` bigint(20) NOT NULL,
                        `status` varchar(32) NOT NULL,
                        `has_initiated` tinyint(4) NOT NULL
		   ) {$charset_collate};";

          //meta data
          $sql[] = "CREATE TABLE {$bp->chat->table_chat_messages} (
			`id` bigint(20) NOT NULL AUTO_INCREMENT,
                          `sender_id` bigint(20) NOT NULL,
                          `channel_id` bigint(20) NOT NULL,
                          `message` text NOT NULL,
                          `sent_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
                          PRIMARY KEY (`id`)
		   ) {$charset_collate};";
	require_once(ABSPATH . 'wp-admin/upgrade-functions.php');
	dbDelta($sql);



	update_site_option( 'bp-chat-db-version', BP_CHAT_DB_VERSION );

}
/**
 * Install bpchat tables
 */
function bpchat_check_installed(){
/* Need to check db tables exist, activate hook no-worky in mu-plugins folder. */
	if ( get_site_option('bp-chat-db-version') < BP_CHAT_DB_VERSION )
            bpchat_install();
}

add_action( 'admin_menu', 'bpchat_check_installed' );
?>